/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lesson9;

import java.util.Objects;

/**
 *
 * @author student
 */
public class Student implements Comparable {

    private String name;
    private int age;
    private final boolean gender;

    @MarkSg(number = 6, value = "Apple")
    public Student(String name, int age, boolean gender) {
        this.name = name;
        this.age = age;
        this.gender = gender;
    }    
    
    /**
     * Creates a new Student instance
     * @param name The name of the Student
     * @param age Age of the Student
     * @param gender Gender of the student
     * @deprecated In v2 this is replaced by public Student(String name, int age, boolean gender)
     */
    @Deprecated
    public Student(String name, int age, char gender) {
        this.name = name;
        this.age = age;
        if (gender=='f') this.gender=true;
        else this.gender=false;
    }

    @Override
    public String toString() {
        /*switch (this.gender) {
            case 'm':
                return name + " " + age + " (male)";
            case 'f':
                return name + " " + age + " (female)";
            default:
                assert false : "Gender prolem"; 
        }*/
        if (gender) return name + " " + age + " (female)";
        else return name + " " + age + " (male)";
    }
    @MarkSg(value = "Pear")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    @Override
    public int compareTo(Object t) {
        //compare the name of this object to the name of t (casted to a Student) compare the age as well
        return this.getName().compareTo(((Student) t).getName());
    }

    @Override
    public int hashCode() {
        int hash = 3;
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Student other = (Student) obj;
        if (!Objects.equals(this.name, other.name)) {
            return false;
        }
        if (this.age != other.age) {
            return false;
        }
        if (this.gender != other.gender) {
            return false;
        }
        return true;
    }

    

}//Student class
